import { select, range, symbols, symbol } from 'd3'; //ES6 to import specifc packages of d3

const width = window.innerWidth;
const height = window.innerHeight;

const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

const n = 100;

svg
  .append('g')
  .selectAll('rect')
  .data(range(n))
  .join('rect')
  .attr('y', (d) => d * 20)
  .attr('width', width)
  .attr('height', 10)
  .attr('mask', 'url(#mask-even-1)'); // to new name

svg
  .append('g')
  .selectAll('rect')
  .data(range(n))
  .join('rect')
  .attr('y', (d) => d * 20)
  .attr('width', width)
  .attr('height', 10)
  .attr('mask', 'url(#mask-odd-1)'); // to new name

svg
  .append('g')
  .selectAll('rect')
  .data(range(n))
  .join('rect')
  .attr('x', (d) => d * 20)
  .attr('width', 10)
  .attr('height', height)
  .attr('mask', 'url(#mask-odd-2)'); //to new name

svg
  .append('g')
  .selectAll('rect')
  .data(range(n))
  .join('rect')
  .attr('x', (d) => d * 20)
  .attr('width', 10)
  .attr('height', height)
  .attr('mask', 'url(#mask-even-2)'); //to new name

const renderMask = (inverted) => {
// create funtion 'renderMask' pass in 'id' and 'inverted' as  local var
// const renderMask = () => { //** is invert necessary here?
  const dataRange = range(symbols.length); // abstracting the range
  const dataRange1 = [0,2,4,6]
  const dataRange2 = [1,3,5]
  
  const maskOdd1 = svg.append('mask').attr("id", 'mask-odd-1'); // name change 'circle-mask'

  const size = 15000;
  
  maskOdd1
    .selectAll('rect') // code block above commented out and change 'g' to 'mask', 'path' to 'g'
    .data(dataRange1) //inserted* creates array of number of symbols)
    .join((enter) =>
      enter
        .append('rect')
        .attr('x', (d,i) => d < 3 ? d * width/3 : (d-3) * width/ 4)//i < 3 ? d * /3 + width/6: (d - 3) *  width/4 
        .attr('y', (d,i) => d < 3 ? 0 : height/2)
        .attr('width', (d,i) => d < 3 ? width/3 : width/ 4)
        .attr('height', height/2))
  			// .attr('id', (d,i) => i % 2 ? 2 : 1)
		    // .attr('fill', (d,i) => i % 2 ?  'white': 'black')
  			.attr('fill', inverted ? 'black': 'white')
  ;

  maskOdd1
    .selectAll('g') // code block above commented out and change 'g' to 'mask', 'path' to 'g'
    .data(dataRange1) //inserted* creates array of number of symbols)
    .join((enter) =>
      enter
        .append('path')
        // .append('g')
        .attr(
          'transform',
          (d, i) =>
            `translate(${
              d < 3 ? d * width/3 + width/6: (d - 3) *  width/4 +  width/8
            },${d < 3 ? height * 0.25 : height * 0.75 })`
        ) //in translate x is first y second
        // .append('path')
    )
    .attr('d', (d) => symbol(symbols[d], size)()) // create a way to chnage the symbol type with each symbol array number can be done with i (index too) = (d,i) => symbol(symbols[i], size)(
    // .attr('fill', (d,i) => i % 2 ? 'black': 'white')
    .attr('fill', inverted ? 'white' : 'black');
  
  const maskEven1 = svg.append('mask').attr("id", 'mask-even-1'); // name change 'circle-mask'

  // maskEven1
  //   .selectAll('rect') // code block above commented out and change 'g' to 'mask', 'path' to 'g'
  //   .data(dataRange2) //inserted* creates array of number of symbols)
  //   .join((enter) =>
  //     enter
  //       .append('rect')
  //       .attr('x', (d,i) => d < 3 ? d * width/3 : (d-3) * width/ 4)//i < 3 ? d * /3 + width/6: (d - 3) *  width/4 
  //       .attr('y', (d,i) => d < 3 ? 0 : height/2)
  //       .attr('width', (d,i) => d < 3 ? width/3 : width/ 4)
  //       .attr('height', height/2))
  // 			// .attr('id', (d,i) => i % 2 ? 2 : 1)
  // // .attr('fill', (d,i) => i % 2 ?  'white': 'black')
  // 			.attr('fill', inverted ? 'white': 'black')
  // ;

  maskEven1
    .selectAll('g') // code block above commented out and change 'g' to 'mask', 'path' to 'g'
    .data(dataRange2) //inserted* creates array of number of symbols)
    .join((enter) =>
      enter
        .append('path')
        // .append('g')
        .attr(
          'transform',
          (d, i) =>
            `translate(${
              d < 3 ? d * width/3 + width/6: (d - 3) *  width/4 +  width/8
            },${d < 3 ? height * 0.25 : height * 0.75 })`
        ) //in translate x is first y second
        // .append('path')
    )
    .attr('d', (d) => symbol(symbols[d], size)()) // create a way to chnage the symbol type with each symbol array number can be done with i (index too) = (d,i) => symbol(symbols[i], size)(
    // .attr('fill', (d,i) => i % 2 ? 'black': 'white')
    .attr('fill', inverted ? 'black': 'white')
  	// .attr('mask', `url(#mask-${(d,i) => i % 2 ? 1 : 2})`)
    // .attr('id', (d,i) => i % 2 ? 1 : 2)
  
  const maskOdd2 = svg.append('mask').attr("id", 'mask-odd-2'); // name change 'circle-mask'

  
  // maskOdd2
  //   .selectAll('rect') // code block above commented out and change 'g' to 'mask', 'path' to 'g'
  //   .data(dataRange1) //inserted* creates array of number of symbols)
  //   .join((enter) =>
  //     enter
  //       .append('rect')
  //       .attr('x', (d,i) => d < 3 ? d * width/3 : (d-3) * width/ 4)//i < 3 ? d * /3 + width/6: (d - 3) *  width/4 
  //       .attr('y', (d,i) => d < 3 ? 0 : height/2)
  //       .attr('width', (d,i) => d < 3 ? width/3 : width/ 4)
  //       .attr('height', height/2))
  // 			// .attr('id', (d,i) => i % 2 ? 2 : 1)
  // // .attr('fill', (d,i) => i % 2 ?  'white': 'black')
  // 			.attr('fill', inverted ? 'white': 'black')
  // ;

  maskOdd2
    .selectAll('g') // code block above commented out and change 'g' to 'mask', 'path' to 'g'
    .data(dataRange1) //inserted* creates array of number of symbols)
    .join((enter) =>
      enter
        .append('path')
        // .append('g')
        .attr(
          'transform',
          (d, i) =>
            `translate(${
              d < 3 ? d * width/3 + width/6: (d - 3) *  width/4 +  width/8
            },${d < 3 ? height * 0.25 : height * 0.75 })`
        ) //in translate x is first y second
        // .append('path')
    )
    .attr('d', (d) => symbol(symbols[d], size)()) // create a way to chnage the symbol type with each symbol array number can be done with i (index too) = (d,i) => symbol(symbols[i], size)(
    // .attr('fill', (d,i) => i % 2 ? 'black': 'white')
    .attr('fill', inverted ? 'black': 'white' );
  
  const maskEven2 = svg.append('mask').attr("id", 'mask-even-2'); // name change 'circle-mask'

  maskEven2
    .selectAll('rect') // code block above commented out and change 'g' to 'mask', 'path' to 'g'
    .data(dataRange2) //inserted* creates array of number of symbols)
    .join((enter) =>
      enter
        .append('rect')
        .attr('x', (d,i) => d < 3 ? d * width/3 : (d-3) * width/ 4)//i < 3 ? d * /3 + width/6: (d - 3) *  width/4 
        .attr('y', (d,i) => d < 3 ? 0 : height/2)
        .attr('width', (d,i) => d < 3 ? width/3 : width/ 4)
        .attr('height', height/2))
  			// .attr('id', (d,i) => i % 2 ? 2 : 1)
		    // .attr('fill', (d,i) => i % 2 ?  'white': 'black')
  			.attr('fill', inverted ? 'black': 'white')
  ;

  maskEven2
    .selectAll('g') // code block above commented out and change 'g' to 'mask', 'path' to 'g'
    .data(dataRange2) //inserted* creates array of number of symbols)
    .join((enter) =>
      enter
        .append('path')
        // .append('g')
        .attr(
          'transform',
          (d, i) =>
            `translate(${
              d < 3 ? d * width/3 + width/6: (d - 3) *  width/4 +  width/8
            },${d < 3 ? height * 0.25 : height * 0.75 })`
        ) //in translate x is first y second
        // .append('path')
    )
    .attr('d', (d) => symbol(symbols[d], size)()) // create a way to chnage the symbol type with each symbol array number can be done with i (index too) = (d,i) => symbol(symbols[i], size)(
    // .attr('fill', (d,i) => i % 2 ? 'black': 'white')
    .attr('fill', inverted ? 'white': 'black')
  	// .attr('mask', `url(#mask-${(d,i) => i % 2 ? 1 : 2})`)
    // .attr('id', (d,i) => i % 2 ? 1 : 2)
};

// renderMask('mask-1', true); // call the function passing the var 'mask-1' as 'id'
renderMask(); // call the function passing the var 'mask-1' as 'id'

// svg
//   .call(renderMask, 'mask-1', false) // call the function passing the var 'mask-1' as 'id'
// 	.call(renderMask, 'mask-2', true);

         
         
         
         
         
         
         

